%define	major		1
%define libname		%mklibname %{name} %{major}
%define develname	%mklibname %{name} -d

%define rel	3
%define subrel	1
%define pre	alpha6
 
Summary:	Conservative garbage collector for C
Name:		gc
Version:	7.2
Release:	%mkrel %{?pre:0.%{pre}.}%{rel}
License:	BSD
Group:		System/Libraries
URL:		http://www.hpl.hp.com/personal/Hans_Boehm/gc/
Source0:	http://www.hpl.hp.com/personal/Hans_Boehm/gc/gc_source/%{name}-%{version}%{?pre:%{pre}}.tar.gz
# fix trying to install two header files twice in the same install command (fixes build)
Patch0:		gc-duplicate-headers-install.patch
Patch1:		gc-7.2alpha6-CVE-2012-2673-calloc.patch
Patch2:		gc-7.2alpha6-CVE-2012-2673-malloc.patch
BuildRequires:	libatomic_ops-devel

%description
Boehm's GC is a garbage collecting storage allocator that is intended to be
used as a plug-in replacement for C's malloc.


%package -n %{libname}
Summary:	Conservative garbage collector for C
Group:		System/Libraries
Obsoletes:	%{name} < 7.1
Provides:	%{name} = %{version}-%{release}

%description -n	%{libname}
Boehm's GC is a garbage collecting storage allocator that is intended to be
used as a plug-in replacement for C's malloc.


%package -n %{develname}
Summary:	Development files and documentation for Bohem's GC
Group:		Development/C
License: 	BSD
Obsoletes:	%{_lib}gc1-devel < 7.1
Obsoletes:	%{_lib}gc-static-devel < 7.2
Provides:	lib%{name}-devel = %{version}-%{release}
Requires:	%{libname} = %{version}-%{release}

%description -n %{develname}
Header files and documentation needed to develop programs that use Bohem's GC

%prep
%setup -q -n %{name}-%{version}%{?pre}
%apply_patches

%build
autoreconf -vfi

# or else tkhtml3 won't build on x86-64. the clean way to do this is
# to patch it into the Makefile, but then it doesn't get used for
# mach_dep.lo, and I can't figure out why not - AdamW 2008/12
%ifarch x86_64
export CFLAGS="%{optflags} -fPIC"
%endif

# from Fedora: see http://bugzilla.redhat.com/689877
export CPPFLAGS="-DUSE_GET_STACKBASE_FOR_MAIN"

%configure2_5x \
	--disable-static \
	--enable-cplusplus \
	--enable-large-config \
%ifarch %{ix86}
	--enable-parallel-mark \
%endif
	--enable-threads=posix
        
%make

%install
%makeinstall_std

rm -rf %{buildroot}%{_datadir}

install -m644 doc/gc.man -D %{buildroot}%{_mandir}/man3/gc.3

#we don't want these
find %{buildroot} -name "*.la" -delete

%check
make check

%files -n %{libname}
%doc README.QUICK
%{_libdir}/*.so.%{major}*

%files -n %{develname}
%doc doc/*.html
%{_libdir}/*.so
%dir %{_includedir}/gc
%{_includedir}/%{name}/*
%{_includedir}/*h
%{_libdir}/pkgconfig/*.pc
%{_mandir}/man?/*


%changelog

* Wed Aug 29 2012 luigiwalser <luigiwalser> 7.2-0.alpha6.3.1.mga2
+ Revision: 285547
- rediff patches from debian to fix CVE-2012-2673

  + kamil <kamil>
    - rebuild against libatomic_ops-7.3.0 alpha2
    - clean .spec

* Sun Feb 05 2012 wally <wally> 7.2-0.alpha6.2.mga2
+ Revision: 204876
- sync build flags and configure options with Fedora

* Tue Dec 27 2011 wally <wally> 7.2-0.alpha6.1.mga2
+ Revision: 188199
- new version 7.2alpha6
- disable static build and drop .la files
- drop mips patch

* Thu Feb 10 2011 dmorgan <dmorgan> 7.1-7.mga1
+ Revision: 49769
- Remove mdv macros
- imported package gc

